# Instructions
$Introduction = "`
`
`
`
`
`
 \ \        /       |          |                              
  \ \  \   /  _  |  __|   __|  __ \   __  __ \    _  |  __ \  `
   \ \  \ /  (   |  |    (     | | |  |   |   |  (   |  |   | `
    \_/\_/  \__,_| \__| \___| _| |_| _|  _|  _| \__,_| _|  _| `
                                                              `
        Windows Setup for Forensic Extractor for YouTube `
`
`
                        thewatchman.pro `
                             2023 `
`
`
`
Before running this setup script, please perform the following actions:
`
1. Download and install Python 3.10 or later from the Microsoft Store or from https://www.python.org/downloads.
2. Download FFmpeg from https://www.gyan.dev/ffmpeg/builds.
3. Extract the archive
4. Rename the folder as ffmpeg
5. Move the folder to C:\Program Files
`
`
`
`
"

Write-Host $Introduction

# Request user confirmation
$valid = $false
while (!$valid) {
    $response = Read-Host "Have you performed the aforementioned actions? (y/n)"
    switch ($response) {
        "y" { $valid = $true; Write-Host "Proceeding...`n" }
        "n" { Write-Host "Requirements have not been met. Exiting...`n"; exit }
        default { Write-Host "Invalid input, please enter 'y' or 'n'.`n" }
    }
}

# Setup the environment variable for ffmpeg
Write-Host "Creating the environment variable for FFmpeg."
$env:Path += ";C:\Program Files\ffmpeg\bin"

# Create new virtual environment
Write-Host "Setting up the Python3 virtual environment."
python3 -m venv __WATCHMAN__

# Activate virtual environment
Write-Host "Activating the Python3 virtual environment.`n"
.\__WATCHMAN__\Scripts\activate

# Install dependencies
Write-Host "Preparing to install required dependencies.`n"
python3 -m pip install --upgrade pip --no-warn-script-location
python3 -m pip install yt_dlp blake3 pytube colr winshell pywin32 --no-warn-script-location

# Setup complete
Write-Host "`nSetup completed successfully.`n"

Write-Host "Launch the virtual environment: .\__WATCHMAN__\Scripts\activate"
Write-Host "Execute the script: python3 .\forensic-extractor-youtube.py`n`n`n"